/*
File: AppNet.java
Date		Author		Changes
Sept 06 96	Lukasz Beca	Created
*/

package webwisdom.tango.messages;


import java.io.*;
import java.net.*;
import webwisdom.tango.messages.AppEventMessage;

/**
 * Objects of this class send and receive messages using network connection
 * 
 *@author Lukasz Beca
 **/

public class AppNet {

  Socket s;
  DataInputStream in;
  DataOutputStream out;
  

/**
   * Creates a new Net object
   *@param sparam socket
   **/

  public AppNet(Socket sparam) {

    s = sparam;
    try {
      in = new DataInputStream(s.getInputStream());
      out = new DataOutputStream(s.getOutputStream());
      

    } catch(Exception e) {
  
        System.out.println("Err: " + e);
	System.exit(1);
    }
    
   
  }

  /**
   * Sends message 
   *@param m message
   *@exception IOException
   **/

  public void send(Message m) throws IOException {

     m.send(out);
   
  }

 

  /**
   * Returns message
   *@return message
   *@exception IOException
   **/


  public AppEventMessage receive() throws IOException {
    
    int type;
    AppEventMessage result;

   // System.out.println("Trying to receive");

    result = new AppEventMessage(in);
             
   // System.out.println("Type of message received " + result.getType());


    return result;

 
  }
 
    

   /**
   * Waits until application registers
   *@return AID of application
   **/

  public int getData() {

    int data;

    System.out.println("retrieving data");
    
    try {
      data = in.readInt();
    } catch(Exception e) {

      System.out.println("Err: " + e);
      System.exit(1);
      data = 0;
    }


    return data;

  }
  
  
  
  /**
   * Closes connection 
   **/ 
  

  public void close() {

    System.out.println("Closing connection");

    try {
      out.flush();
      out.close();
      in.close();
      s.close();
    } catch(Exception e) {
      
        System.out.println("Err: " + e);
    }
    
  }
}

